/******************************************************************************************
   Class Trie and Node By Navid Hamed Azimi
   This class is supposed to get a large list of pointers to an string and create, insert,search,
   and maintain a trie of all of the strings. The trie is supposed to search only the whole strings,prefix and suffix
   It does not have the ability to search substrings.

   Class Node is supposed to be a Node of the Trie.

   myList is a link list to store the strings at the end of each trie, The reason for not using stl is memory and speed.
   each vector or other stl classes has minimum 40 byte overhead but mylist only have a size of a pointer overhead which is 8 or 4.
   Since by the calculations most of the time it will only contain one string and it will never grow more than 4 or five so we don't need
   the length parameter as well.

/******************************************************************************************/
#ifndef NavidTrieClass
#define NavidTrieClass

#include <string>
#include <vector>


//#include "header.h"
#include "ControlPanel.cpp"
#include "read-processor.h"
#include <iostream>



// reportingDebug1 turn on a counter that show the status of building the first blocks of the trie.
#define  reportingDebug1

namespace NavidSemiCompactTrie {




  using namespace std;
  class TrieNode;
  class myList;


  static string stringtemp="";
  static int thirdCounter=0;
  static int counterList=0;
  static int counterNode=0;


  namespace ReadsVectorSpace {
#ifndef readsVect
    static ReadProcessor* readsVect;
#endif
  }



  class readPointer {
  public :
    mar_types  status;
    int ID;
    readPointer() {
      ID=-1;
    }
    inline const string& stringData() {
      if (ID==-1) { return stringtemp; }
      return ReadsVectorSpace::readsVect->GetMar(ID,status);
    };
    inline string toStream() {
      char buffer[50];
      sprintf(buffer,"%d %d",ID,status);
      string s=buffer;
      return s;
    }
  };




  class myList {
  public:
    readPointer data;
    myList* next;
#define myListStartTag -1
#define myListEndTag -2
    inline bool checkString(const string& s,int index,int missMatchesAllowed) {
      string t=s.substr(index,1000);
      if (this->data.stringData().length()!=s.length()) { return false;}
      if (missMatchNumber(this->data.stringData(), t, index,missMatchesAllowed)>missMatchesAllowed) return false;
      return true;
    }
    inline myList(readPointer inp1){
      data=inp1;
      next=NULL;
    };
    ~myList(){
      destruct();
    };
    void destruct() {
      if (next!=NULL) {
	next->destruct();
	delete next;
      }
    }
    myList(const myList& inp1){
      throw "this class should have never been used this way";
    }
    int size() {
      if (next==NULL) {
	return 1;
      }
      else return next->size()+1;
    }
    void addToList(readPointer input) {
      if (next==NULL) {
	next=new myList(input);
      } else next->addToList(input);
    };
    void addToList(myList* input) {
      myList* temp=this;
      while (temp->next!=NULL) {
	temp=temp->next;
      }
      temp->next=input;
    };
  }; // enf of mylist class
  static int secondcounter=0;
  static readPointer tempResults[200000];
  static int tempResultsOffset[200000];
  static int numberResultsSofar;
  static int counterIt=0;
  static int counterIt1=0;
  static int counterIt2=0;
  static int counterIt3=0;
  static int counterIt4=0;
  static int counterIt5=0;
  static int counterIt6=0;
  static int counterIt7=0;
  static TrieNode* nodeTemp;
  static myList* listTemp;
  static int uselesscounter=0;
  static int convertedString[10000];



  class NavidIntPointerStruct {
  public:
    int AlphabetParsed;
    TrieNode* currentNode;
    int currentError;
  };

  static NavidIntPointerStruct tempStack[1000];
  static int currentStackPoistion;



  class NavidIntIntStruct {
  public:
    int leafsCount;
    int nodeCount;
    NavidIntIntStruct() {
      leafsCount=0;
      nodeCount=0;
    };
  };


  class TrieNode  {


    // static temp variables

  public:
#define TrieNodeStartTag -3
#define TrieNodeEndTag -4
    bool isChildLeaf[alphabetNumber];
    //	  string theEdge;
    void* childs[alphabetNumber];
    //	  myList* CompleteStrings;

    TrieNode(){
      //			CompleteStrings=NULL;
      for (int i = 0; i <alphabetNumber; i++) {
	this->isChildLeaf[i]=true;
	this->childs[i]=NULL;
      }
    };
    //Copy Constructor
    TrieNode(const TrieNode& inp) {
      throw "you shouldn't use copy constructor for this object";
    };

    //Destructor Free the Nodes;
    ~TrieNode() {
      //	destructNode();
    }
    void destructNode() {

      //		  if (CompleteStrings!=NULL) delete CompleteStrings;
      for (int i = 0; i <alphabetNumber; i++) {
	if (this->isChildLeaf[i]) {
	  listTemp=(myList*)this->childs[i];
	  if (listTemp!=NULL) delete listTemp;
	}
	else {
	  nodeTemp=(TrieNode*)this->childs[i];
	  if (nodeTemp!=NULL) delete nodeTemp;
	  //				delete nodeTemp;
	}
      }//*/
    };

    void addPairReadToTrie(int ID) {
      readPointer temp;
      temp.ID=ID;
      temp.status=LMAR;
      addToTrie(temp);
      temp.status=RMAR;
      addToTrie(temp);
      temp.status=LMARRC;
      addToTrie(temp);
      temp.status=RMARRC;
      addToTrie(temp);
    }
    void addPairReadToRightTrie(int ID) {
      readPointer temp;
      temp.ID=ID;
      temp.status=RMAR;
      addToTrie(temp);
      temp.status=RMARRC;
      addToTrie(temp);
    }
    void addPairReadToLeftTrie(int ID) {
      if (ID==50000) {
	//				cout<<"What the hell"<<endl;
      }
      readPointer temp;
      temp.ID=ID;
      temp.status=LMAR;
      addToTrie(temp);
      temp.status=LMARRC;
      addToTrie(temp);
    }

    void constructTrie() {
      int j=ReadsVectorSpace::readsVect->TotalPairs();
      cout<<endl<<"number of reads added to Trie"<<ReadsVectorSpace::readsVect->TotalPairs()<<endl;
      for (int i=0; i <j; i++) {
	if (i>199900000) {
	  //				cout<<i<<" "<<counterNode<<endl;
	}  else
	  if ( ((i/10000.0)-(double)(i/10000))<0.000001)
	    cout<<i<<" ";
	addPairReadToTrie(i);
      }
    }

    void constructLeftTrie() {
      cout<<endl<<"the Number of reads are ";
      int j=ReadsVectorSpace::readsVect->TotalPairs();
      cout<<endl<<"the Number of reads are "<<j;
      for (int i=0; i <j; i++) {
	if (i>190000000) {
	  //				cout<<i<<" "<<counterNode<<endl;
	}  else
	  if ( ((i/10000.0)-(double)(i/10000))<0.000001)
	    cout<<i<<" ";
	addPairReadToLeftTrie(i);
      }
    }
    void constructRightTrie() {
      int j=ReadsVectorSpace::readsVect->TotalPairs();
      cout<<endl<<"the Number of reads are "<<j;
      for (int i=0; i <j; i++)
	addPairReadToRightTrie(i);
    }
    vector<readPointer> searchWithError(const string& s,int errorAllowed) {
      vector<readPointer> result;
      //			if (s.length()<=index) {
      //				throw "error in search, you are trying to search for a part of string that exceed its size";
      //		}
      numberResultsSofar=0;
      //			searchWithErrorAllowedNonRecursive(s,errorAllowed);
      searchWithErrorAllowed(s,errorAllowed);
      result.resize(numberResultsSofar);
      for (int i=0; i < numberResultsSofar; i++)
	result[i]=tempResults[i];
      return result;
    }
  private:
    void searchWithErrorAllowed(const string& s,int errorRemained,int index=0) {
      /*			counterIt++;
				for (int hhh=0;hhh<index;hhh++) cout<<" ";
				cout<<index<<" ";
				cout<<errorRemained<<" ";
				cout<<s[index]<<endl;/*/
      if (index>=s.size()) {
	if (index==s.size()) {
	  //						listTemp=CompleteStrings;
	  while (listTemp!=NULL) {
	    tempResults[numberResultsSofar]=listTemp->data;
	    numberResultsSofar++;
	    listTemp=listTemp->next;
	  }
	}
	//				else
	//					throw "error in search, you are trying to search for a part of string that exceed its size";
      }
      short int i=getIndex(s[index]);
      if (errorRemained==0) {
	//	   if (errorRemained<0)
	//   		throw "error in search function";
	if (this->childs[i]==NULL)
	  return;
	if (this->isChildLeaf[i]) {
	  //					counterIt2++;
	  listTemp=(myList*)(this->childs[i]);
	  if (listTemp->checkString(s,index+1,0)) {
	    while (listTemp!=NULL) {
	      tempResults[numberResultsSofar]=listTemp->data;
	      numberResultsSofar++;
	      listTemp=listTemp->next;
	    }
	  }
	}
	else {
	  nodeTemp=(TrieNode*)(this->childs[i]);
	  nodeTemp->searchWithErrorAllowed(s,0,index+1);
	}
	return;
      }
      short int nextStepError;
      short int j=0;
      for (j = 0; j <alphabetNumber; j++) {
	if (this->childs[j]!=NULL) {
	  //					counterIt3++;
	  if (i==j) nextStepError=errorRemained; else nextStepError=errorRemained-1;
	  //					nextStepError=(i==j)?errorRemained:errorRemained-1;
	  if (this->isChildLeaf[j]) {
	    listTemp=(myList*)(this->childs[j]);
	    if (listTemp->checkString(s,index+1,nextStepError)) {
	      while (listTemp!=NULL) {
		tempResults[numberResultsSofar]=listTemp->data;
		numberResultsSofar++;
		listTemp=listTemp->next;
	      }
	    }
	  }
	  else {
	    nodeTemp=(TrieNode*)(this->childs[j]);
	    nodeTemp->searchWithErrorAllowed(s,nextStepError,index+1);
	  }
	}
      }
      return;
    };
    //	   private:
    void addToTrie(myList* inp1, int index=0) {
      if (inp1->data.stringData().length()<=index) {
	if (inp1->data.stringData().length()==index) {
	  /*				if (CompleteStrings==NULL) {
	  //							CompleteStrings=inp1;
	  //					}
	  //					else
	  this->CompleteStrings->addToList(inp1);/*/
	}
	else
	  throw "error in trie add function. parsing characters of string greater than its size";
	return;
      }
      int t=getIndex(inp1->data.stringData()[index]);
      if (this->childs[t]==NULL) {
	this->isChildLeaf[t]=true;
	this->childs[t]=inp1;
	return;
      } else if (this->isChildLeaf[t]) {
	listTemp=(myList*)this->childs[t];
	if (listTemp->data.stringData()==inp1->data.stringData()) {
	  listTemp->addToList(inp1);
	  return;
	}
	nodeTemp=new TrieNode();
	this->childs[t]=(void*)nodeTemp;
	this->isChildLeaf[t]=false;
	nodeTemp->addToTrie(listTemp,index+1);
	nodeTemp->addToTrie(inp1,index+1);
	return;
      }
      nodeTemp=(TrieNode*)this->childs[t];
      nodeTemp->addToTrie(inp1,index+1);
    } // end of main add to tire function
  public:
    inline void addToTrie(readPointer inp1,int index=0) {
      if (inp1.stringData().length()<5) {
	//				  cout << "got length: " << inp1->data.stringData().length() << endl;
	throw "error you shouldn't add strings of less than size 5 to trie";
      }
      myList* temp=new myList(inp1);
      addToTrie(temp,index);
    }

  public:
    NavidIntIntStruct traceTrie() {
      int betoch=0;
      NavidIntIntStruct res;
      /*		   if (this->CompleteStrings!=NULL) {
			   betoch++;
			   res.leafsCount=res.leafsCount+this->CompleteStrings->size();
			   }/*/
      //		   int betoch2=0;
      for (int j = 0; j <alphabetNumber; j++) {
	if (this->childs[j]!=NULL) {
	  betoch++;
	  if (this->isChildLeaf[j]) {
	    listTemp=(myList*)this->childs[j];
	    res.leafsCount=res.leafsCount+listTemp->size();
	  }
	  else {
	    nodeTemp=(TrieNode*)(this->childs[j]);
	    NavidIntIntStruct res2=nodeTemp->traceTrie();
	    res.nodeCount=res.nodeCount+res2.nodeCount;
	    res.leafsCount=res.leafsCount+res2.leafsCount;
	  }
	}
      }
      if (betoch<2) {
	uselesscounter++;
      }
      res.nodeCount=res.nodeCount+1;
      return res;
    }



    void searchWithErrorAllowedNonRecursive(const string& s,int errorRemained) {
      currentStackPoistion=0;
      tempStack[currentStackPoistion].currentNode=this;
      tempStack[currentStackPoistion].AlphabetParsed=0;
      int ssize=s.size();
      tempStack[currentStackPoistion].currentError=errorRemained;


      int i;
      for (i=0; i < ssize; i++)
	convertedString[i]=getIndex(s[i]);

#define curNode tempStack[currentStackPoistion].currentNode
#define currentParse tempStack[currentStackPoistion].AlphabetParsed
      int 		errorAllowed;

      while (currentStackPoistion>=0) {
	//				counterIt++;
	//				currentNode=tempStack[currentStackPoistion].currentNode;
	//				currentParse=tempStack[currentStackPoistion].AlphabetParsed;
	if (!(currentParse<alphabetNumber)) {
	  currentStackPoistion--;
	  tempStack[currentStackPoistion].AlphabetParsed++;
	  continue;
	}
	i=convertedString[currentStackPoistion];
	if (i==currentParse)
	  errorAllowed=tempStack[currentStackPoistion].currentError;
	else
	  errorAllowed=tempStack[currentStackPoistion].currentError-1;

	if (curNode->childs[currentParse]!=NULL) {
	  if (errorAllowed<=0) {
	    int index=currentStackPoistion;
	    i=convertedString[index];
	    while (!(curNode->isChildLeaf[i])) {
	      curNode=(TrieNode*)curNode->childs[i];
	      index++;
	      i=convertedString[index];
	    }
	    if (curNode->childs[i]==NULL) {
	      //						return;
	    } else  {
	      //								counterIt++;
	      listTemp=(myList*)(curNode->childs[i]);
	      if (listTemp->checkString(s,index+1,0)) {
		while (listTemp!=NULL) {
		  tempResults[numberResultsSofar]=listTemp->data;
		  numberResultsSofar++;
		  listTemp=listTemp->next;
							
		}
	      }
	    }
	  } else
	    if (curNode->childs[currentParse]!=NULL) {
	      if (curNode->isChildLeaf[currentParse]) {
		listTemp=(myList*)(curNode->childs[currentParse]);
		//								counterIt++;
		if (listTemp->checkString(s,currentStackPoistion+1,errorAllowed)) {
		  while (listTemp!=NULL) {
		    tempResults[numberResultsSofar]=listTemp->data;
		    numberResultsSofar++;
		    listTemp=listTemp->next;
		  }
		}
	      }
	      else {
		nodeTemp=(TrieNode*)(curNode->childs[currentParse]);
		currentStackPoistion++;
		tempStack[currentStackPoistion].currentNode=nodeTemp;
		tempStack[currentStackPoistion].AlphabetParsed=0;
		tempStack[currentStackPoistion].currentError=errorAllowed;
		continue;
	      }
	    }

	}
	tempStack[currentStackPoistion].AlphabetParsed++;
      }
    }// end of search function

    void searchWithErrorWholeSeed(const string& s,int errorAllowed,int readSize,IntIntMtTripleVec& left,IntIntMtTripleVec& right) {

      numberResultsSofar=0;
      for (int i=0; i < s.length()-readSize; i++) {
	int offset=numberResultsSofar;
	string t=s.substr(i,readSize);
	searchWithErrorAllowedNonRecursive(t,errorAllowed);

	for (int j=offset; j <numberResultsSofar; j++) {
	  /*					
						if (tempResults[j].stringData()!=t) {
						cout<<missMatchNumber(tempResults[j].stringData(),t,0,100)<<" ";
						} 
						//                    else//*/
	  tempResultsOffset[j]=i;
	}
      }
      cout<<"search level 2 iscompleted"<<endl;
      int leftNum=0;
      int rightNum=0;
      for (int i=0; i < numberResultsSofar; i++) {
	if (tempResultsOffset[i]>-1) {
	  if ((tempResults[i].status==LMAR) || (tempResults[i].status==LMARRC)) leftNum++;
	  else if ((tempResults[i].status==RMAR) || (tempResults[i].status==RMARRC)) rightNum++;
	}
      }
      left.resize(leftNum);
      right.resize(rightNum);
      int leftIndex=0;
      int rightIndex=0;
      for (int i=0; i < numberResultsSofar; i++) {
	if ((tempResults[i].status==LMAR) || (tempResults[i].status==LMARRC)) {
	  left[leftIndex].first=tempResults[i].ID;
	  left[leftIndex].second=tempResultsOffset[i];
	  left[leftIndex].third=tempResults[i].status;
	  leftIndex++;
	}
	else
	  if ((tempResults[i].status==RMAR) || (tempResults[i].status==RMARRC)) {
	    right[rightIndex].first=tempResults[i].ID;
	    right[rightIndex].second=tempResultsOffset[i];
	    right[rightIndex].third=tempResults[i].status;
	    rightIndex++;
	  }
      }
      return;
    }
  }; //end of Trie Node Class

}

#endif



