#ifndef COMPACT_TRIE_H
#define COMPACT_TRIE_H

#include "header.h"
#include "read-processor.h"
#include <string>
#include <cstdio>

#include "ControlPanel.cc"

class TrieNode;
class ReadProcessor;

static string stringtemp = "";
#ifndef readsVect
static ReadProcessor* readsVect;
#endif

class readPointer {
 public :
  mar_types  status;
  int ID;
  readPointer() {
    ID = -1;
  }
  inline const string& stringData() {
    if (ID == -1) { return stringtemp; }
    return readsVect->GetMar(ID, status);
  };
  inline string toStream() {
    char buffer[50];
    sprintf(buffer, "%d %d", ID, status);
    string s = buffer;
    return s;
  }
};

class myList {
 public:
  readPointer data;
  myList* next;
#define myListStartTag -1
#define myListEndTag -2
  inline bool checkString(const string& s, int index, int missMatchesAllowed) {
    string t = s.substr(index, 1000);
    if (this->data.stringData().length()!=s.length()) { return false;}
    if (missMatchNumber(this->data.stringData(), t, index,
			missMatchesAllowed) > missMatchesAllowed) return false;
    return true;
  }
  inline myList(readPointer inp1){
    data = inp1;
    next = NULL;
  }
  ~myList(){
    destruct();
  }
  void destruct() {
    if (next != NULL) {
      next->destruct();
      delete next;
    }
  }
  myList(const myList& inp1){
    throw "this class should have never been used this way";
  }
  int size() {
    if (next == NULL) {
      return 1;
    }
    else return next->size() + 1;
  }
  void addToList(readPointer input) {
    if (next == NULL) {
      next = new myList(input);
    } else next->addToList(input);
  }
  void addToList(myList* input) {
    myList* temp = this;
    while (temp->next!=NULL) {
      temp=temp->next;
    }
    temp->next=input;
  }
}; // enf of mylist class  

class NavidIntPointerStruct {
 public:
  int AlphabetParsed;
  TrieNode* currentNode;
  int currentError;
};

class NavidIntIntStruct {
 public:
  int leafsCount;
  int nodeCount;
  NavidIntIntStruct() {
    leafsCount=0;
    nodeCount=0;
  }
};

class TrieNode  {
 public:
#define TrieNodeStartTag -3
#define TrieNodeEndTag -4
  
  TrieNode();
  
  //Destructor Free the Nodes;
  ~TrieNode() {}
  
  IntMtPair Search(const string& s);
  void Insert(int ID, mar_types status);

  void addPairReadToTrie(int ID);
  
  void constructTrie();
  
  vector<readPointer> searchWithError(const string& s,int errorAllowed);
  
  inline void addToTrie(readPointer inp1, int index = 0) {
    if (inp1.stringData().length() < 5) {
      throw "error you shouldn't add strings of less than size 5 to trie";
    }
    myList* temp = new myList(inp1);
    addToTrie(temp, index);
  }
  
  NavidIntIntStruct traceTrie();
  
  void searchWithErrorAllowedNonRecursive(const string& s, int errorRemained);

  void searchWithErrorWholeSeed(const string& s,int errorAllowed,int readSize,IntIntMtTripleVec& left,IntIntMtTripleVec& right);

  IntIntMtTripleVec searchWithErrorWholeSeed(const string& s,int errorAllowed,int readSize);

 private:
  TrieNode(const TrieNode& inp) {
    throw "you shouldn't use copy constructor for this object";
  }
  void destructNode();

  void searchWithErrorAllowed(const string& s, int errorRemained, int index = 0);

  void addToTrie(myList* inp1, int index = 0);

  bool isChildLeaf[alphabetNumber];
  void* childs[alphabetNumber];  
}; //end of Trie Node Class

#endif  // COMPACT_TRIE_H
