#include <bitset>
#include <iostream>
#include <sstream>

using namespace std;

const int MAX = 1000;
const int INF = 10000000;

int m[MAX][MAX], p[MAX][MAX][2];

// We will only allow deletion from 'a' or 'b' if the character is '?'.
int overlap(const string& a, const string& b, int *score, string* c) {

  // Initialize.
  for (int i = 1; i <= b.size(); ++i) {
    m[0][i] = -1;
    p[0][i][0] = -1;
  }

  // Base case.
  for (int i = 0; i <= a.size(); ++i) {
    m[i][0] = 0;
    p[i][0][0] = -1;
  }
  for (int i = 1; i <= a.size(); ++i) {
    for (int j = 1; j <= b.size(); ++j) {
      m[i][j] = -1;
      p[i][j][0] = -1;

      // Cost for substitution of '?' is zero.
      if (a[i - 1] == b[j - 1] || a[i - 1] == '?' || b[j - 1] == '?' ||
	  a[i - 1] == 'N' || b[j - 1] == 'N') {
	int t = m[i - 1][j - 1];
	if (t >= 0) {
	  if (a[i - 1] != '?' && a[i - 1] != 'N' &&
	      b[j - 1] != '?' && b[j - 1] != 'N') t += 2;
	}
	if (t >= m[i][j] ) {
	  m[i][j] = t;
	  p[i][j][0] = i - 1;
	  p[i][j][1] = j - 1;
	}
      }

      // Cost for deletion of a '?' is zero. 
      if (a[i - 1] == '?') {
	if (m[i - 1][j] > m[i][j]) {
	  m[i][j] = m[i - 1][j];
	  p[i][j][0] = i - 1;
	  p[i][j][1] = j;
	}
      }
      if (b[j - 1] == '?') {
	if (m[i][j - 1] > m[i][j]) {
	  m[i][j] = m[i][j - 1];
	  p[i][j][0] = i;
	  p[i][j][1] = j - 1;
	}
      }
    }
  }
  int enda = -1;
  int endb = -1;
  int t = -1;
  bool swallow = false;

  // Check whether 'b' is completely swallowed by 'a'.
  for (int i = 1; i <= a.size(); ++i) {
    if (m[i][b.size()] > t) {
      t = m[i][b.size()];
      enda = i;
      endb = b.size();
      swallow = true;
    }
  }

  //if (endb != -1) {
  //  cout << "swallowed\n";
  //  return;
  //}

  // If not swallowed, check for overlap.
  if (enda == -1) {
    t = -1;
    for (int i = 1; i <= b.size(); ++i) {
      if (m[a.size()][i] > t) {
	t = m[a.size()][i];
	enda = a.size();
	endb = i;
      }
    }
  }

  //  if (endb != -1) {
  //  cout << endb << endl;
  // return;
  //}
  //  cout << "nothing happened\n";
  if (enda == -1) {
    *c = "";
    *score = 0;
    return 0;
  }
  int o = 0, s = m[enda][endb], tenda = enda, tendb = endb;
  string str;
  ostringstream sout;
  while (p[enda][endb][0] != -1) {
    int ta = enda;
    int tb = endb;
    enda = p[ta][tb][0];
    endb = p[ta][tb][1];
    if (ta !=  enda && tb != endb) {
      sout << (a[ta - 1] == '?' ? b[tb - 1] : a[ta - 1]);
      //if (a[ta - 1] != '?' && b[tb - 1] != '?') s += 2;
      ++o;
    }
  }
  str = sout.str();
  reverse(str.begin(), str.end());
  if (swallow) {
    *c = a.substr(0, enda) + str + a.substr(tenda, a.size() - tenda);
  } else { 
    *c = a.substr(0, enda) + str + b.substr(tendb, b.size() - tendb);
  }
  //  cout << str << endl;
  *score = s;
  //*c = str;
  //cout << enda << " " << *c << endl;
  return o;
}

int main() {
  string a, b, c;
  int s, o;

  while (cin >> a >> b) {
    o = overlap(a, b, &s, &c);
    cout << o << " " << s << " " << c << endl;
  }
  return 0;
}
