#include "kmar-table.h"
#include "utils-string.h"

#include <iostream>

//////////BAD//////////////
bool CmpIntPair(const IntPair& a, const IntPair& b) {
  return a.first < b.first;
}
//////////////////////////

KmarTable::KmarTable(const string& str, IntVec* table) {
  table_ = table;
  int val = UtilsString::String2Int(str, 0, KMAR_LEN);
  table_[val].push_back(0);
  for (int i = 1; i + KMAR_LEN <= str.size(); ++i) {
    val =
      ((val - (UtilsString::Base2Int(str[i - 1]) << ((KMAR_LEN - 1) << 1)))
       << 2) + UtilsString::Base2Int(str[i + KMAR_LEN - 1]);
    table_[val].push_back(i);
  }
}

// IntPairVec KmarTable::GetGluedPos(const string& a) const {
//   IntPairVec pos;
//   int val = UtilsString::String2Int(a, 0, KMAR_LEN);
//   for (int i = 0; i < table_[val].size(); ++i) {
//     pos.push_back(IntPair(table_[val][i], 0));
//   }
//   for (int i = 1; i + KMAR_LEN <= a.size(); ++i) {
//     val =
//       ((val - (UtilsString::Base2Int(a[i - 1]) << ((KMAR_LEN - 1) << 1))) << 2)
//       + UtilsString::Base2Int(a[i + KMAR_LEN - 1]);
//     //if (table_[val].size() == 1) cout << "unique pos found\n";
//     for (int j = 0; j < table_[val].size(); ++j) {
//       pos.push_back(IntPair(table_[val][j], i));
//     }
//   }
//   sort(pos.begin(), pos.end(), CmpIntPair);
//   return pos;
// }

IntVec KmarTable::GetGluedPos(const string& a) const {
  IntVec pos;
  int val = UtilsString::String2Int(a, 0, KMAR_LEN);
  for (int i = 0; i < table_[val].size(); ++i) {
    pos.push_back(table_[val][i]);
  }
  for (int i = 1; i + KMAR_LEN <= a.size(); ++i) {
    val =
      ((val - (UtilsString::Base2Int(a[i - 1]) << ((KMAR_LEN - 1) << 1))) << 2)
      + UtilsString::Base2Int(a[i + KMAR_LEN - 1]);
    //if (table_[val].size() == 1) cout << "unique pos found\n";
    for (int j = 0; j < table_[val].size(); ++j) {
      pos.push_back(table_[val][j]);
    }
  }
  sort(pos.begin(), pos.end());
  return pos;
}

void KmarTable::GetRange(const string& a, int* minimum, int* maximum) const {
  int val = UtilsString::String2Int(a, 0, KMAR_LEN);
  int x = INF, y = -INF; 
  for (int i = 0; i < table_[val].size(); ++i) {
    x = min(x, table_[val][i]);
    y = max(y, table_[val][i]);
  }
  for (int i = 1; i + KMAR_LEN <= a.size(); ++i) {
    val =
      ((val - (UtilsString::Base2Int(a[i - 1]) << ((KMAR_LEN - 1) << 1))) << 2) +
      UtilsString::Base2Int(a[i + KMAR_LEN - 1]);
    for (int j = 0; j < table_[val].size(); ++j) {
      x = min(x, table_[val][j]);
      y = max(y, table_[val][j]);
    }
  }
  *minimum = x;
  *maximum = y;
}
