#include "vote.h"
#include <iostream>

//using namepsace std;

int Vote::MAX_VAL = 1 << 15;

Vote::Vote() {
  fill(base_, base_ + BASE_TYPES, 0);
}

Vote::Vote(const Vote& v) {
  for (int i = 0; i < BASE_TYPES; ++i) {
    base_[(base_types)i] = v[(base_types)i];
  }
}

Vote::Vote(int a, int t, int g, int c) {
  base_[BASEA] = a >= MAX_VAL ? MAX_VAL - 1 : a;
  base_[BASET] = t >= MAX_VAL ? MAX_VAL - 1 : t;
  base_[BASEG] = g >= MAX_VAL ? MAX_VAL - 1 : g;
  base_[BASEC] = c >= MAX_VAL ? MAX_VAL - 1 : c;
  
  assert(base_[BASEA] >= 0 && base_[BASEA] < MAX_VAL);
  assert(base_[BASET] >= 0 && base_[BASET] < MAX_VAL);
  assert(base_[BASEG] >= 0 && base_[BASEG] < MAX_VAL);
  assert(base_[BASEC] >= 0 && base_[BASEC] < MAX_VAL);
}

void Vote::Inc(base_types bt, int x) {
  base_[bt] += x;
  if (base_[bt] >= MAX_VAL - 2) base_[bt] = MAX_VAL - 2;
  //  assert(base_[bt] >= 0 && base_[bt] < MAX_VAL);
}

char Vote::MaxBase() const {
  int a = base_[BASEA];
  int t = base_[BASET];
  int g = base_[BASEG];
  int c = base_[BASEC];
  if (a >= t && a >= g && a >= c) return 'A';
  if (t >= a && t >= g && t >= c) return 'T';
  if (g >= a && g >= t && g >= c) return 'G';
  if (c >= a && c >= t && c >= g) return 'C';
}

int Vote::MaxVote() const {
  int m = 0;
  int a = base_[BASEA];
  int t = base_[BASET];
  int g = base_[BASEG];
  int c = base_[BASEC];
  m = max(m, a);
  m = max(m, t);
  m = max(m, g);
  m = max(m, c);
  return m;
}

sint Vote::operator [] (base_types i) const {
  return base_[i];
}

sint& Vote::operator [] (base_types i) {
  return base_[i];
}

bool Vote::operator == (const Vote& v) const {
  for (int i = 0; i < BASE_TYPES; ++i) {
    if (base_[i] != v[(base_types)i]) return false;
  }
  return true;
}

bool Vote::operator != (const Vote& v) const {
  return !(*this == v);
}

//#include <iostream>
//using namespace std;

void Vote::operator += (const Vote& v) {
  for (int i = 0; i < BASE_TYPES; ++i) {
    int t = (int)base_[(base_types)i] + (int)v[(base_types)i];
    if (t >= MAX_VAL) t = MAX_VAL - 1;
    if (t < 0) {
      cout << (int)base_[(base_types)i] << " " << (int)v[(base_types)i] << endl;
    }
    base_[(base_types)i] = t;
    assert(base_[(base_types)i] >= 0);
  }
}

istream& operator >> (istream& is, Vote& v) {
  Vote t;
  for (int i = 0; i < BASE_TYPES; ++i) {
    int x;
    is >> x;
    t.Inc((base_types)i, x);
  }
  v = t;
  return is;
}
